--*****************************************************************
-- UVanim_tool_gmax
--   Modified : 2009.08.16
--   Original Script : By Deniska
--   URL: http://www.gtaforums.com/index.php?showtopic=277798&st=0
--*****************************************************************


-----------------------------------------------------------------------------------------------
fn repSpace str1 = (
	local i,str2=""
	for i = 1 to str1.count do(
		if str1[i] == " " then str2 += "~"
		else str2 += str1[i]
		)
	str2
) -- fn repSpace
-----------------------------------------------------------------------------------------------
fn copyData f1 f2 N = (
local i, b , nmax , ntmp
nmax = 64
-- for i = 1 to N do (b = readByte f1 ; writeByte f2 b ) 
while N > 0 do (
	if N > nmax then (ntmp = nmax ; N -= nmax)
	else (ntmp = N ; N -= nmax)
	format ("b " + ntmp as string)
	for i = 1 to ntmp do ( b = readByte f1 ; format (" " + b as string) )
	format ("\n")
	f2[1] += ntmp
	) -- while N > 0
) -- fn copyData
-----------------------------------------------------------------------------------------------

fn copyHeader f H = (
-- writeLong f H[1]
-- writeLong f H[2]
-- writeLong f H[3]
format ("i 3 " + H[1] as string + " "  + H[2] as string + " "  + H[3] as string + "\n") ; f[1] += 12
)

-----------------------------------------------------------------------------------------------

fn readHeader f = (
 local i, res = #()
 b = readLong f #unsigned
 res[1] = b
 b = readLong f #unsigned
 res[2] = b
 b = readLong f #unsigned
 res[3] = b
 res
)

-----------------------------------------------------------------------------------------------
fn findHeader f ID Size = (
	local res = #(), H, EndPos = ftell f + Size
	res[4] = false
	
	while ftell f < EndPos do (
		if not res[4] then (
			H = readHeader f
			if H[3] == 0x1803FFFF then (
				if H[1] == ID then (
					res[1] = H[1]
					res[2] = H[2]
					res[3] = H[3]
					res[4] = true
					) --if H[1] == ID
				else (
					res = findHeader f ID H[2]
					) -- else H[1] == ID
				) -- if H[3] == 0x1803FFFF
			else (
				fseek f (Size-12) #seek_cur -- pass data
				) -- else H[3] == 0x1803FFFF
			) -- if not res[4]
		else (
			exit
			) -- else not res[4]
		) -- while
	res
	) -- end findHeader

-------------------------------------------------------------------------------------------
fn GetAKeys bmap = (
local AKeys = #(), Keys_u_offset, Keys_v_offset, Keys_u_tiling, Keys_v_tiling
local AStartKey, AEndKey, i, k

Keys_u_offset = bmap.coords.u_offset.keys
Keys_v_offset = bmap.coords.v_offset.keys
Keys_u_tiling = bmap.coords.u_tiling.keys
Keys_v_tiling = bmap.coords.v_tiling.keys
--Keys_w_angle = bmap.coords.w_angle.keys

format ("Keys_u_offset = " + bmap.coords.u_offset.keys as string + "\n")
format ("Keys_v_offset = " + bmap.coords.v_offset.keys as string + "\n")
format ("Keys_u_tiling = " + bmap.coords.u_tiling.keys as string + "\n")
format ("Keys_v_tiling = " + bmap.coords.v_tiling.keys as string + "\n")

AStartKey = animationRange.start
AEndKey = animationRange.end

format ("AStartKey" + animationRange.start as string +"\n")
format ("AEndKey " + animationRange.end as string +"\n")

append AKeys AStartKey
append AKeys AEndKey

for i = 1 to Keys_u_offset.count do (
 k = Keys_u_offset[i].time
  if k>=AStartKey and k<=AEndKey do 
   if (findItem AKeys k) == 0 do append AKeys k
)
for i = 1 to Keys_v_offset.count do (
 k = Keys_v_offset[i].time
  if k>=AStartKey and k<=AEndKey do
   if (findItem AKeys k) == 0 do append AKeys k
)
for i = 1 to Keys_u_tiling.count do (
 k = Keys_u_tiling[i].time
  if k>=AStartKey and k<=AEndKey do
   if (findItem AKeys k) == 0 do append AKeys k
)
for i = 1 to Keys_v_tiling.count do (
 k = Keys_v_tiling[i].time
  if k>=AStartKey and k<=AEndKey do
   if (findItem AKeys k) == 0 do append AKeys k
)

for i = 1 to AKeys.count-1 do
 for j = i+1 to AKeys.count do
   if AKeys[i]>AKeys[j] do swap AKeys[i] AKeys[j]
   
format ("AKeys " + AKeys as string +"\n")

AKeys   

) -- end GetAKeys

-----------------------------------------------------------------------------------------------

fn getAData bmap AKeys = (
local i, uo, vo, ut, vt, res = #()

for i = 1 to AKeys.count do (
 -- SliderTime = AKeys[i]
 at time AKeys[i] uo = bmap.coords.u_offset
 at time AKeys[i] vo = bmap.coords.v_offset
 at time AKeys[i] ut = bmap.coords.u_tiling
 at time AKeys[i] vt = bmap.coords.v_tiling
 res[i] = #((AKeys[i] as float)/4800.0, 0.0, ut, vt, 0.0, -uo, vo, i-2 )
)

SliderTime = 0

res
)
-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------

rollout UVanimTool_rol "" width:190 height:364
(
	button exp "Append animation" pos:[25,280] width:138 height:26
	checkbox gtamaxON "Use GTAmax.exe" checked:true width:200
	materialButton pickMat "pick material" pos:[24,18] width:135 height:24
	bitmap bmp2 "Bitmap" pos:[25,49] width:128 height:128
	groupBox grp1 "" pos:[3,4] width:183 height:176
	groupBox grp2 "" pos:[3,182] width:183 height:150
	button SelectDFF "Select DFF" pos:[14,195] width:161 height:26
	dropdownlist TList "Texture to aplay" pos:[9,224] width:171 height:5
	
local bmap, TexNum, TexList, AMatList, f, fname, ASize
	
on pickMat picked mtl do (
 if isKindOf mtl Gta_Mtl then 
  if mtl.colormap == undefined then messageBox "No texture in material" 
  else (
   bmap = mtl.colorMap
   pickMat.text = mtl.name
   bmap.coords.u_offset.controller = linear_float ()
   bmap.coords.v_offset.controller = linear_float ()
   bmap.coords.u_tiling.controller = linear_float ()
   bmap.coords.v_tiling.controller = linear_float ()
   bmp2.fileName = bmap.fileName
  )
 else 
 if  isKindOf mtl Standard then 
  if mtl.DiffuseMap == undefined then messageBox "No texture in material"
  else (
   bmap = mtl.DiffuseMap
   pickMat.text = mtl.name
   bmap.coords.u_offset.controller = linear_float ()
   bmap.coords.v_offset.controller = linear_float ()
   bmap.coords.u_tiling.controller = linear_float ()
   bmap.coords.v_tiling.controller = linear_float ()   
   bmp2.fileName = bmap.fileName
  )
  else  (
   pickMat.material = undefined
   pickMat.text = "pick material"
   MessageBox "select Standard or KAM's GTA material"
   bmp2.bitmap = undefined
  )
) -- on pickMat pressed

on SelectDFF pressed do (
clearlistener()
 fname = getOpenFileName caption:"select DFF" types:"DFF (*.dff)|*.dff|"
 if fname != undefined do (
  f = fopen fname "rb"
  if f == undefined then ( messageBox "Can't open file"
                           SelectDFF.text = "Select DFF")
  else (
	TexNum = 0
	TexList = #()
	AMatList = #()
	ASize = #()
	DataSize = getFileSize fname
	SelectDFF.text = getFileNameFile fname

	
	while true do (
	FH = findHeader f 0x07 DataSize --Material (0x0007) 
	 if not FH[4] do exit
	 TexNum += 1	 
	 CurPos = ftell f
	 DataSize = FH[2]
	 FH = findHeader f 0x06 DataSize -- Texture (0x0006) 
	 CurPos2 = ftell f
	 if FH[4] then (
	  fseek f 28 #seek_cur -- 28 =12(head) + 4 + 12(head)
	  TexList[TexNum] = readString f
      fseek f (CurPos2 + FH[2]) #seek_set -- Texture > Extension (0x0003)
	  H = readHeader f
	  ASize[TexNum] = H[2]	  -- Texture > Extension (0x0003) ̃TCY
	  fseek f CurPos #seek_set
	  FH = findHeader f 0x135 DataSize -- UV Animation PLG (0x0135) 
	  if FH[4] then (
	   H = ReadHeader f
	   fseek f 4 #seek_cur
	   AMatList[TexNum] = readString f
	  )
	  else AMatList[TexNum] = undefined -- No UV Animation PLG (0x0135)
	 )
	 else ( AMatList[TexNum] = undefined ; TexList[TexNum] = "<-- no texture -->")
	 
	 fseek f CurPos #seek_set
	 DataSize = getFileSize fname - ftell f
   ) -- while
   
   TTList = #()
   for i = 1 to TexList.count do 
    if AMatList[i] != undefined then TTList[i] = TexList[i] + " (A)"
	                            else TTList[i] = TexList[i]
   TList.Items = TTList
--if TexNum>30 then TList.height = 29*10
--                else TList.height = TexNum * 10 + 20
  fclose f
  ) -- end else f==undefined  
 ) -- if fname != undefined					 
) -- on DFF pressed

	
--test code--
on _exp pressed do (
	clearlistener()
	format (repSpace("aaa bbb") as string +"\n")
)
--------------


on exp pressed do (
 if bmap == undefined then MessageBox "Select material"
 else (
   f = fopen fname "rb"
   if f == undefined then MessageBox "Select DFF"
   else (
if (findItem AMatList PickMat.material.name) > 0 and
	    TList.selection != (findItem AMatList PickMat.material.name) then 
	      messageBox "need rename your material (DFF have material with same name)"
	else 
	if TList.items[TList.selection] == "<-- no texture -->" then
	      MessageBox "<-- no texture --> in dropdown list its mean NO TEXTURE"
	else (
	 FPath = getFileNamePath fname
	 tempfname = FPath + "temp_" + (filenameFromPath fname)
--	 tempf = fopen tempfname "wb"
	 tempf = #() ; tempf[1] = 0
	 tempf2 = #() ; tempf2[1] = 0
	 fseek f 4 #seek_set
	 AnimSize = readLong f #unsigned
	 fseek f 0 #seek_set

	 AKeys = GetAKeys bmap
	 AData = getAData bmap AKeys
	 
     SizeInc = 84 - ASize[TList.selection]										   
	 
	 AReplace = if AMatList[TList.selection]!= undefined then true
	                                                     else false
	 
	 AMatList[TList.selection] = PickMat.material.name
	 AMats = 0
	 for i = 1 to AMatList.count do	(
	       if AMatList[i] != undefined do AMats += 1   
	       )



------- Calc DataSize of UV Animation Dictionary (0x002B) -----
	 fseek f 0 #seek_set
	 
	 -- UV Anim Dictionary
	 format ("i 3 " + (0x2B) as string + " 0 " + (0x1803FFFF) as string + "\n") ; tempf2[1] += 12

	 -- UV Anim Dictionary/struc
	 format ("i 4 " + (0x01) as string + " 4 " + (0x1803FFFF) as string + " " + AMats as string + "\n")  ; tempf2[1] += 16
	 
	 -- Old Animations
	 for i = 1 to AMats do (
	  FH = findHeader f 0x1B AnimSize -- Anim Animation (0x001B) 
	  if FH[4] do (
	  CurPos = ftell f
	  fseek f 24 #seek_cur
	  str = readString f
	  fseek f CurPos #seek_set
	  if (findItem AMatList str) != TList.selection and (findItem AMatList str)>0 then (
	   copyHeader tempf2 FH
	   copyData f tempf2 FH[2]
	  )
	  else fseek f FH[2] #seek_cur
	  ) -- FH[4]
	 ) -- for i
	 
	 -- New Anim header
	 format ("i 3 " + (0x1B) as string + " " + (88 + AKeys.count*32) as string + " " + (0x1803FFFF) as string + "\n")  ; tempf2[1] += 12
	 -- New Anim Data
	 format ("i 3 256 449 " + AKeys.count as string + "\n")  ; tempf2[1] += 12
	 format ("f 2 0.0 " + ((AKeys[AKeys.count] as float)/4800.0) as string + "\n")  ; tempf2[1] += 8
	 format ("i 1 0\n")  ; tempf2[1] += 4
	 format ("c 64 " + repSpace(AMatList[TList.selection]) + "\n")  ; tempf2[1] += 64

     for i = 1 to AKeys.count do (
     format ("f 7 ")
	  for j = 1 to 7 do (format (AData[i][j] as string + " ") ; tempf2[1] += 4)
	  format ("i 1 " + AData[i][8] as string +"\n") ; tempf2[1] += 4
	 )

------- snoopstart for gtamax-----

		format "\n"             --Don't remove this, it solve some win98 user problem
		clearlistener()
		if gtamaxON.checked == true then 	format "<snoopstart file=%>\n" tempfname
		else 	format "<!--path=\"%\"-->\n" tempfname

	 
------- UV Animation Dictionary (0x002B) -----
	 fseek f 0 #seek_set
	 
	 -- UV Anim Dictionary
--	 writeLong tempf 0x2B -- UV Animation Dictionary (0x002B) 
--	 writeLong tempf 0
--	 writeLong tempf 0x1803FFFF
	 format ("i 3 " + (0x2B) as string + " " + (tempf2[1] - 12) as string +  " " + (0x1803FFFF) as string + "\n") ; tempf[1] += 12

	 -- UV Anim Dictionary/struc
--	 writeLong tempf 0x01 -- UV Anim Dictionary/struc
--	 writeLong tempf 4
--	 writeLong tempf 0x1803FFFF	
--   writeLong tempf AMats
	 format ("i 4 " + (0x01) as string + " 4 " + (0x1803FFFF) as string + " " + AMats as string + "\n")  ; tempf[1] += 16
	 
	 -- Old Animations
	 for i = 1 to AMats do (
	  FH = findHeader f 0x1B AnimSize -- Anim Animation (0x001B) 
	  if FH[4] do (
	  CurPos = ftell f
	  fseek f 24 #seek_cur
	  str = readString f
	  fseek f CurPos #seek_set
	  if (findItem AMatList str) != TList.selection and (findItem AMatList str)>0 then (
	   copyHeader tempf FH
	   copyData f tempf FH[2]
	  )
	  else fseek f FH[2] #seek_cur
	  ) -- FH[4]
	 ) -- for i
	 
	 -- New Anim header
--	 writeLong tempf 0x1B
--	 writeLong tempf (88 + AKeys.count*32)
--	 writeLong tempf 0x1803FFFF
	 format ("i 3 " + (0x1B) as string + " " + (88 + AKeys.count*32) as string + " " + (0x1803FFFF) as string + "\n")  ; tempf[1] += 12
	 -- New Anim Data
--	 CurPos = ftell tempf
--	 writeLong tempf 256 #unsigned -- 4bytes
--	 writeLong tempf 449 #unsigned -- 4bytes
--	 writeLong tempf (AKeys.count) #unsigned  -- 4bytes
	 format ("i 3 256 449 " + AKeys.count as string + "\n")  ; tempf[1] += 12
--	 writeFloat tempf 0.0  -- 4bytes
--	 writeFloat tempf ((AKeys[AKeys.count] as float)/4800.0)  -- 4bytes
	 format ("f 2 0.0 " + ((AKeys[AKeys.count] as float)/4800.0) as string + "\n")  ; tempf[1] += 8
--	 writeLong tempf 0  #unsigned  -- 4bytes
	 format ("i 1 0\n")  ; tempf[1] += 4
--	 writeString tempf AMatList[TList.selection]
---	 format ("c 64 " + AMatList[TList.selection] + "\n")  ; tempf[1] += 64
	 format ("c 64 " + repSpace(AMatList[TList.selection]) + "\n")  ; tempf[1] += 64
--	 fseek tempf (CurPos+88) #seek_set

     for i = 1 to AKeys.count do (
     format ("f 7 ")
--	  for j = 1 to 7 do writeFloat tempf AData[i][j]
	  for j = 1 to 7 do (format (AData[i][j] as string + " ") ; tempf[1] += 4)
--	  writeLong tempf AData[i][8]
	  format ("i 1 " + AData[i][8] as string +"\n") ; tempf[1] += 4
	 )

--	 CurPos = tempf[1]
--	 fseek tempf 4 #seek_set
--	 writeLong tempf (CurPos - 12) -- set Anim Size
--	 format ("i 1 " + (CurPos - 12) as string + "\n") ; tempf[1] += 4
--	 fseek tempf CurPos #seek_set 
	 
	 
----- copy CLUMP -----
	 
	 fseek f 0 #seek_set                        --- copy CLUMP
	 FH = findHeader f 0x10 (FSize = getFileSize fname) -- Clump (0x0010) 
	 FH[2] += SizeInc + (if not AReplace and AMats == 1 then 36 else 0)
	 copyHeader tempf FH
	 
	 H = readHeader f  --- Clump/stru
	 copyHeader tempf H
	 copyData f tempf H[2]
	 
	 H = readHeader f  --- Clump/frame list
	 copyHeader tempf H
	 copyData f tempf H[2]
	 
	 H = readHeader f  --- Clump/geom list
	 H[2] += SizeInc
	 copyHeader tempf H
	 
	 H = readHeader f  --- Clump/geom list / stru
	 copyHeader tempf H
	 copyData f tempf H[2]
	 
	 H = readHeader f  --- Clump/glist/geometrya
	 H[2] += SizeInc
	 copyHeader tempf H
	 
	 H = readHeader f  --- Clump/glist/geomertia / stru
	 copyHeader tempf H
	 copyData f tempf H[2]
	 
	 H = readHeader f  --- Clump/..../Matlist
	 H[2] += SizeInc
	 copyHeader tempf H
	 
	 H = readHeader f  --- Clump/..../Matlist/stru
	 copyHeader tempf H
	 copyData f tempf H[2]
	 
	 for i = 1 to TList.items.count do 
	  if i != TList.selection then ( 
	   H = readHeader f  -- material
	   copyHeader tempf H
	   copyData f tempf H[2]	  
	  ) 
	  else (
	   H = readHeader f  -- material 
	   H[2] += SizeInc
	   copyHeader tempf H
  	   H = readHeader f  --- ../ stru
	   copyHeader tempf H
	   copyData f tempf H[2]
	   H = readHeader f  --- ../ texture
	   copyHeader tempf H
	   copyData f tempf H[2]
  	   H = readHeader f  --- ../ exten
	   fseek f H[2] #seek_cur
       H[2] = 84
       copyHeader tempf H
	   H[1] = 0x120; H[2] = 12 ; copyHeader tempf H
--	   writeLong tempf 5 #unsigned 
--	   writeLong tempf 5 #unsigned 
--	   writeLong tempf 0 #unsigned 
	 format ("i 3 5 5 9\n") ; tempf[1] += 12
	   H[1] = 0x135; H[2] = 48 ; copyHeader tempf H -- UV Animation PLG (0x0135) 
	   H[1] = 0x01; H[2] = 36 ; copyHeader tempf H
--	   CurPos = ftell tempf
--	   writeLong tempf 1 #unsigned
--	   writeString tempf AMatList[i]
--	   for j = 1 to 32 do writeByte tempf 0 
--	   fseek tempf (CurPos+36) #seek_set
	 format ("i 1 1 c 32 " + repSpace(AMatList[i]) + "\n") ; tempf[1] += 36
	  ) -- end if i!= .... / else 
	 
	 if not AReplace and AMats == 1 do (	 
	  CurPos = ftell f
	  FH = findHeader f 0x14 (getFileSize fname - CurPos) -- Atomic (0x0014) 
	  DSize = ftell f - CurPos - 12
      fseek f CurPos #seek_set	 
	  copyData f tempf DSize
	  FH[2] += 36
	  copyHeader tempf FH
	  fseek f 12 #seek_cur
  	  H = readHeader f  --- ..Atomik / stru
	  copyHeader tempf H
	  copyData f tempf H[2]	  
  	  H = readHeader f  --- ..Atomik / exten
	  H[2]=36
	  copyHeader tempf H
	  H[1] = 0x1F; H[2] = 8 ; copyHeader tempf H
--	  writeLong tempf 288 #unsigned
--	  writeLong tempf 0 #unsigned
	 format ("i 2 288 0\n") ; tempf[1] += 8
	  H[1] = 0x120; H[2] = 4 ; copyHeader tempf H
--	  writeLong tempf 1 #unsigned
	 format ("i 1 1\n") ; tempf[1] += 4
	 )
	  
	  copyData f tempf ((getFileSize fname) - (ftell f))
	 
--	 format "Data appended\n"

-----  snoopend for gtamax -----

		if gtamaxON.checked == true then 	format "</snoopend>\n"
		format "//"             --Don't remove this, it solve some win98 user problem

---------------------------------

messagebox ("Data appended\n" \
            + "f : " + (ftell f) as string + "\n" \
            + "tmpf = " + tempf as string + "\n")
	 fclose f
	 f = undefined
--	 fclose tempf
	 tempf = undefined
	 --copyFile tempfname fname
     --deleteFile tempfname
	 TList.items = #()
     SelectDFF.text = "Select DFF"
    )
  ) -- else f == undefined
  ) -- else bmap == undefined
  ) -- on exp pressed
) -- roll

try (closeRolloutFloater uvtool_flo) catch () 
uvtool_flo = newRolloutFloater "UV anim export" 205 400 20 130 
addRollout  UVanimTool_rol uvtool_flo